Loading...
Searching...
No Matches
ON_Arc Class Reference

`#include <pcl/surface/3rdparty/opennurbs/opennurbs_arc.h>`

Inheritance diagram for ON_Arc:

## Public Member Functions

| ON_Arc ()
| ON_Arc (const ON_Circle &circle, double angle_in_radians)
| ON_Arc (const ON_Circle &circle, ON_Interval angle_interval_in_radians)
| ON_Arc (const ON_Plane &plane, double radius, double angle_in_radians)
| ON_Arc (const ON_3dPoint &center, double radius, double angle_in_radians)
| ON_Arc (const ON_Plane &plane, const ON_3dPoint &center, double radius, double angle_in_radians)
| ON_Arc (const ON_2dPoint &start_point, const ON_2dPoint &interior_point, const ON_2dPoint &end_point)
| ON_Arc (const ON_3dPoint &start_point, const ON_3dPoint &interior_point, const ON_3dPoint &end_point)
bool | Create (const ON_Circle &circle, double angle_in_radians)
bool | Create (const ON_Circle &circle, ON_Interval angle_interval_in_radians)
bool | Create (const ON_Plane &plane, double radius, double angle_in_radians)
bool | Create (const ON_3dPoint &center, double radius, double angle_in_radians)
bool | Create (const ON_Plane &plane, const ON_3dPoint &center, double radius, double angle_in_radians)
bool | Create (const ON_2dPoint &start_point, const ON_2dPoint &interior_point, const ON_2dPoint &end_point)
bool | Create (const ON_3dPoint &start_point, const ON_3dPoint &interior_point, const ON_3dPoint &end_point)
bool | Create (const ON_2dPoint &start_point, const ON_2dVector &dir_at_start, const ON_2dPoint &end_point)
bool | Create (const ON_3dPoint &start_point, const ON_3dVector &dir_at_start, const ON_3dPoint &end_point)
ON_Arc & | operator= (const ON_Circle &)
| ~ON_Arc ()
void | Dump (ON_TextLog &dump) const
bool | IsValid () const
ON_BoundingBox | BoundingBox () const
bool | GetBoundingBox (ON_BoundingBox &bbox, int bGrowBox=false) const
bool | GetTightBoundingBox (ON_BoundingBox &tight_bbox, int bGrowBox=false, const ON_Xform *xform=0) const
bool | IsCircle () const
double | AngleRadians () const
double | AngleDegrees () const
ON_Interval | Domain () const
ON_Interval | DomainRadians () const
ON_Interval | DomainDegrees () const
bool | SetAngleRadians (double angle_in_radians)
bool | SetAngleIntervalRadians (ON_Interval angle_in_radians)
bool | Trim (ON_Interval domain_radian)
bool | SetAngleDegrees (double angle_in_degrees)
ON_3dPoint | StartPoint () const
ON_3dPoint | MidPoint () const
ON_3dPoint | EndPoint () const
bool | ClosestPointTo (const ON_3dPoint &test_point, double *t) const
ON_3dPoint | ClosestPointTo (const ON_3dPoint &test_point) const
double | Length () const
double | SectorArea () const
ON_3dPoint | SectorAreaCentroid () const
double | SegmentArea () const
ON_3dPoint | SegmentAreaCentroid () const
bool | Reverse ()
int | GetNurbForm (ON_NurbsCurve &nurbs_curve) const
bool | GetRadianFromNurbFormParameter (double nurbs_parameter, double *arc_radians_parameter) const
bool | GetNurbFormParameterFromRadian (double arc_radians_parameter, double *nurbs_parameter) const
Public Member Functions inherited from ON_Circle
| ON_Circle ()
| ON_Circle (const ON_Plane &plane, double radius)
| ON_Circle (const ON_3dPoint &center, double radius)
| ON_Circle (const ON_Plane &plane, const ON_3dPoint &center, double radius)
| ON_Circle (const ON_2dPoint &P, const ON_2dPoint &Q, const ON_2dPoint &R)
| ON_Circle (const ON_3dPoint &P, const ON_3dPoint &Q, const ON_3dPoint &R)
| ~ON_Circle ()
bool | Create (const ON_Plane &plane, double radius)
bool | Create (const ON_3dPoint &center, double radius)
bool | Create (const ON_Plane &plane, const ON_3dPoint &center, double radius)
bool | Create (const ON_2dPoint &P, const ON_2dPoint &Q, const ON_2dPoint &R)
bool | Create (const ON_3dPoint &P, const ON_3dPoint &Q, const ON_3dPoint &R)
bool | Create (const ON_2dPoint &P, const ON_2dVector &tangent_at_P, const ON_2dPoint &Q)
bool | Create (const ON_3dPoint &P, const ON_3dVector &tangent_at_P, const ON_3dPoint &Q)
bool | IsValid () const
bool | IsInPlane (const ON_Plane &, double=ON_ZERO_TOLERANCE) const
double | Radius () const
double | Diameter () const
double | Circumference () const
const ON_3dPoint & | Center () const
const ON_3dVector & | Normal () const
const ON_Plane & | Plane () const
ON_BoundingBox | BoundingBox () const
bool | GetTightBoundingBox (ON_BoundingBox &tight_bbox, int bGrowBox=false, const ON_Xform *xform=0) const
bool | Transform (const ON_Xform &)
ON_3dPoint | PointAt (double) const
ON_3dVector | DerivativeAt (int, double) const
ON_3dVector | TangentAt (double) const
bool | ClosestPointTo (const ON_3dPoint &point, double *t) const
ON_3dPoint | ClosestPointTo (const ON_3dPoint &point) const
double | EquationAt (const ON_2dPoint &plane_point) const
ON_2dVector | GradientAt (const ON_2dPoint &plane_point) const
bool | Rotate (double sin_angle, double cos_angle, const ON_3dVector &axis_of_rotation)
bool | Rotate (double angle_in_radians, const ON_3dVector &axis_of_rotation)
bool | Rotate (double sin_angle, double cos_angle, const ON_3dVector &axis_of_rotation, const ON_3dPoint &center_of_rotation)
bool | Rotate (double angle_in_radians, const ON_3dVector &axis_of_rotation, const ON_3dPoint &center_of_rotation)
bool | Translate (const ON_3dVector &delta)
bool | Reverse ()
int | GetNurbForm (ON_NurbsCurve &nurbs_curve) const
bool | GetRadianFromNurbFormParameter (double nurbs_parameter, double *circle_radians_parameter) const
bool | GetNurbFormParameterFromRadian (double circle_radians_parameter, double *nurbs_parameter) const

## Friends

bool | ON_BinaryArchive::ReadArc (ON_Arc &)
bool | ON_BinaryArchive::WriteArc (const ON_Arc &)

## Additional Inherited Members

Public Attributes inherited from ON_Circle
ON_Plane | plane
double | radius

## Detailed Description

Definition at line 34 of file opennurbs_arc.h.

## Constructor & Destructor Documentation

## ON_Arc() [1/8]

ON_Arc::ON_Arc | ( |  | ) |

## ON_Arc() [2/8]

ON_Arc::ON_Arc | ( | const ON_Circle & | circle,
|  | double | angle_in_radians
| ) |  |

## ON_Arc() [3/8]

ON_Arc::ON_Arc | ( | const ON_Circle & | circle,
|  | ON_Interval | angle_interval_in_radians
| ) |  |

## ON_Arc() [4/8]

ON_Arc::ON_Arc | ( | const ON_Plane & | plane,
|  | double | radius,
|  | double | angle_in_radians
| ) |  |

## ON_Arc() [5/8]

ON_Arc::ON_Arc | ( | const ON_3dPoint & | center,
|  | double | radius,
|  | double | angle_in_radians
| ) |  |

## ON_Arc() [6/8]

ON_Arc::ON_Arc | ( | const ON_Plane & | plane,
|  | const ON_3dPoint & | center,
|  | double | radius,
|  | double | angle_in_radians
| ) |  |

## ON_Arc() [7/8]

ON_Arc::ON_Arc | ( | const ON_2dPoint & | start_point,
|  | const ON_2dPoint & | interior_point,
|  | const ON_2dPoint & | end_point
| ) |  |

## ON_Arc() [8/8]

ON_Arc::ON_Arc | ( | const ON_3dPoint & | start_point,
|  | const ON_3dPoint & | interior_point,
|  | const ON_3dPoint & | end_point
| ) |  |

## ~ON_Arc()

ON_Arc::~ON_Arc | ( |  | ) |

## Member Function Documentation

## AngleDegrees()

double ON_Arc::AngleDegrees | ( |  | ) | const

## AngleRadians()

double ON_Arc::AngleRadians | ( |  | ) | const

## BoundingBox()

ON_BoundingBox ON_Arc::BoundingBox | ( |  | ) | const

## ClosestPointTo() [1/2]

ON_3dPoint ON_Arc::ClosestPointTo | ( | const ON_3dPoint & | test_point | ) | const

## ClosestPointTo() [2/2]

bool ON_Arc::ClosestPointTo | ( | const ON_3dPoint & | test_point,
|  | double * | t
| ) |  | const

## Create() [1/9]

bool ON_Arc::Create | ( | const ON_2dPoint & | start_point,
|  | const ON_2dPoint & | interior_point,
|  | const ON_2dPoint & | end_point
| ) |  |

## Create() [2/9]

bool ON_Arc::Create | ( | const ON_2dPoint & | start_point,
|  | const ON_2dVector & | dir_at_start,
|  | const ON_2dPoint & | end_point
| ) |  |

## Create() [3/9]

bool ON_Arc::Create | ( | const ON_3dPoint & | center,
|  | double | radius,
|  | double | angle_in_radians
| ) |  |

## Create() [4/9]

bool ON_Arc::Create | ( | const ON_3dPoint & | start_point,
|  | const ON_3dPoint & | interior_point,
|  | const ON_3dPoint & | end_point
| ) |  |

## Create() [5/9]

bool ON_Arc::Create | ( | const ON_3dPoint & | start_point,
|  | const ON_3dVector & | dir_at_start,
|  | const ON_3dPoint & | end_point
| ) |  |

## Create() [6/9]

bool ON_Arc::Create | ( | const ON_Circle & | circle,
|  | double | angle_in_radians
| ) |  |

## Create() [7/9]

bool ON_Arc::Create | ( | const ON_Circle & | circle,
|  | ON_Interval | angle_interval_in_radians
| ) |  |

## Create() [8/9]

bool ON_Arc::Create | ( | const ON_Plane & | plane,
|  | const ON_3dPoint & | center,
|  | double | radius,
|  | double | angle_in_radians
| ) |  |

## Create() [9/9]

bool ON_Arc::Create | ( | const ON_Plane & | plane,
|  | double | radius,
|  | double | angle_in_radians
| ) |  |

## Domain()

ON_Interval ON_Arc::Domain | ( |  | ) | const

## DomainDegrees()

ON_Interval ON_Arc::DomainDegrees | ( |  | ) | const

## DomainRadians()

ON_Interval ON_Arc::DomainRadians | ( |  | ) | const

## Dump()

void ON_Arc::Dump | ( | ON_TextLog & | dump | ) | const

## EndPoint()

ON_3dPoint ON_Arc::EndPoint | ( |  | ) | const

## GetBoundingBox()

bool ON_Arc::GetBoundingBox | ( | ON_BoundingBox & | bbox,
|  | int | bGrowBox = `false`
| ) |  | const

## GetNurbForm()

int ON_Arc::GetNurbForm | ( | ON_NurbsCurve & | nurbs_curve | ) | const

## GetNurbFormParameterFromRadian()

bool ON_Arc::GetNurbFormParameterFromRadian | ( | double | arc_radians_parameter,
|  | double * | nurbs_parameter
| ) |  | const

## GetRadianFromNurbFormParameter()

bool ON_Arc::GetRadianFromNurbFormParameter | ( | double | nurbs_parameter,
|  | double * | arc_radians_parameter
| ) |  | const

## GetTightBoundingBox()

bool ON_Arc::GetTightBoundingBox | ( | ON_BoundingBox & | tight_bbox,
|  | int | bGrowBox = `false`,
|  | const ON_Xform * | xform = `0`
| ) |  | const

## IsCircle()

bool ON_Arc::IsCircle | ( |  | ) | const

## IsValid()

bool ON_Arc::IsValid | ( |  | ) | const

## Length()

double ON_Arc::Length | ( |  | ) | const

## MidPoint()

ON_3dPoint ON_Arc::MidPoint | ( |  | ) | const

## operator=()

ON_Arc & ON_Arc::operator= | ( | const ON_Circle & |  | ) |

## Reverse()

bool ON_Arc::Reverse | ( |  | ) |

## SectorArea()

double ON_Arc::SectorArea | ( |  | ) | const

## SectorAreaCentroid()

ON_3dPoint ON_Arc::SectorAreaCentroid | ( |  | ) | const

## SegmentArea()

double ON_Arc::SegmentArea | ( |  | ) | const

## SegmentAreaCentroid()

ON_3dPoint ON_Arc::SegmentAreaCentroid | ( |  | ) | const

## SetAngleDegrees()

bool ON_Arc::SetAngleDegrees | ( | double | angle_in_degrees | ) |

## SetAngleIntervalRadians()

bool ON_Arc::SetAngleIntervalRadians | ( | ON_Interval | angle_in_radians | ) |

## SetAngleRadians()

bool ON_Arc::SetAngleRadians | ( | double | angle_in_radians | ) |

## StartPoint()

ON_3dPoint ON_Arc::StartPoint | ( |  | ) | const

## Trim()

bool ON_Arc::Trim | ( | ON_Interval | domain_radian | ) |

## Friends And Related Symbol Documentation

## ON_BinaryArchive::ReadArc

bool ON_BinaryArchive::ReadArc | ( | ON_Arc & |  | ) |

friend

## ON_BinaryArchive::WriteArc

bool ON_BinaryArchive::WriteArc | ( | const ON_Arc & |  | ) |

friend

The documentation for this class was generated from the following file:

- pcl/surface/3rdparty/opennurbs/opennurbs_arc.h